=== modified file 'client/drizzle.c'
--- client/drizzle.c	2008-07-19 02:56:45 +0000
+++ client/drizzle.c	2008-07-23 00:05:15 +0000
@@ -94,6 +94,16 @@
 
 #include <readline/readline.h>
 
+/**
+ Make the old readline interface look like the new one.
+*/
+#ifndef USE_NEW_READLINE_INTERFACE
+typedef CPPFunction rl_completion_func_t;
+typedef Function rl_compentry_func_t;
+#define rl_completion_matches(str, func) \
+  completion_matches((char *)str, (CPFunction *)func)
+#endif
+
 
 #if !defined(HAVE_VIDATTR)
 #undef vidattr
@@ -2099,10 +2109,8 @@
 ******************************************************************/
 
 
-#ifdef HAVE_READLINE_COMPLETION
 static char *new_command_generator(const char *text, int);
 extern char **new_mysql_completion (const char *text, int start, int end);
-#endif
 
 /*
   Tell the GNU Readline library how to complete.  We want to try to complete
@@ -2199,14 +2207,11 @@
   /* Allow conditional parsing of the ~/.inputrc file. */
   rl_readline_name= (char *)name;
 
-#ifdef HAVE_READLINE_COMPLETION
   /* Tell the completer that we want a crack first. */
   rl_attempted_completion_function= (rl_completion_func_t*)&new_mysql_completion;
   rl_completion_entry_function= (rl_compentry_func_t*)&no_completion;
-#endif
 }
 
-#ifdef HAVE_READLINE_COMPLETION
 /*
   Attempt to complete on the contents of TEXT.  START and END show the
   region of TEXT that contains the word to complete.  We can use the
@@ -2301,7 +2306,6 @@
   }
   return NullS;
 }
-#endif
 
 
 /* Build up the completion hash */

=== modified file 'configure.ac'
--- configure.ac	2008-07-22 00:36:21 +0000
+++ configure.ac	2008-07-23 00:05:15 +0000
@@ -329,6 +329,9 @@
 fi
 AC_CHECK_LIB(z, crc32, [], [AC_MSG_ERROR(could not find libz)])
 
+#--------------------------------------------------------------------
+# Check for libreadline or compatible (libedit on Mac OS X)
+#--------------------------------------------------------------------
 
 AC_CHECK_HEADERS([readline/readline.h])
 if test "x$ac_cv_header_readline_readline_h" != "xyes"
@@ -336,6 +339,8 @@
   AC_MSG_ERROR([Couldn't find readline/readline.h. Try installing readline development packages.])
 fi
 
+MYSQL_CHECK_NEW_RL_INTERFACE
+
 #--------------------------------------------------------------------
 # Check for libpcre
 #--------------------------------------------------------------------

